from liblinearutil import *
import numpy as np
import lmdb
import caffe

min_feature_idx = 1
min_label = 1
dataset_train = 'news20.binary.modified'
y_orig, x_orig = svm_read_problem(dataset_train)

dataset_test = dataset_train + '.t'
y_orig_test, x_orig_test = svm_read_problem(dataset_test)

col_count_train = max([max([key for key in row]) for row in x_orig])
col_count_test = max([max([key for key in row]) for row in x_orig_test])
col_count = max(col_count_train, col_count_test)

xTrain = np.zeros([len(x_orig), col_count])
yTrain = np.array(y_orig)
xTest  = np.zeros([len(x_orig_test), col_count])
yTest = np.array(y_orig_test)

for i in range(len(x_orig)):
    row = x_orig[i]
    for key in row:
        xTrain[i, key - min_feature_idx]=row[key]

for i in range(len(x_orig_test)):
    row = x_orig_test[i]
    for key in row:
        xTest[i, key - min_feature_idx]=row[key]

map_size_train = xTrain.nbytes * 10
NTrain = len(y_orig)
lmdbdataset = dataset_train + 'lmdb'
env = lmdb.open(lmdbdataset, map_size=map_size_train)
with env.begin(write=True) as txn:
    # txn is a Transaction object
    for i in range(NTrain):
        datum = caffe.proto.caffe_pb2.Datum()
        datum.channels = xTrain.shape[1]
        datum.height = 1
        datum.width = 1
        #datum.data = xTrain[i].tobytes()  # or .tostring() if numpy < 1.9
        datum.float_data.extend(xTrain[i])
        datum.label = int(yTrain[i] - min_label)
        str_id = '{:08}'.format(i)

        # The encode is only essential in Python 3
        txn.put(str_id.encode('ascii'), datum.SerializeToString())


map_size_test = xTest.nbytes * 10
NTest = len(y_orig_test)
lmdbdataset = dataset_test + 'lmdb'
env = lmdb.open(lmdbdataset, map_size=map_size_test)
with env.begin(write=True) as txn:
    # txn is a Transaction object
    for i in range(NTest):
        datum = caffe.proto.caffe_pb2.Datum()
        datum.channels = xTest.shape[1]
        datum.height = 1
        datum.width = 1
        #datum.data = xTest[i].tobytes()  # or .tostring() if numpy < 1.9
        datum.float_data.extend(xTest[i])
        datum.label = int(yTest[i] - min_label)
        str_id = '{:08}'.format(i)

        # The encode is only essential in Python 3
        txn.put(str_id.encode('ascii'), datum.SerializeToString())

