import sys
from liblinearutil import *
import numpy as np
import scipy.io as sio
import re

min_feature_idx = 1
dataset_train = sys.argv[1]
dataset = re.split('\.', dataset_train)
dataset = dataset[0]
y_orig, x_orig = svm_read_problem(dataset_train)

dataset_test = sys.argv[2]
y_orig_test, x_orig_test = svm_read_problem(dataset_test)

col_count_train = max([max([key for key in row]) for row in x_orig])
col_count_test  = max([max([key for key in row]) for row in x_orig_test])
col_count = max(col_count_train, col_count_test)

xTrain  = np.zeros([len(x_orig), col_count])
yTrain  = np.array(y_orig)
yTrain -= min(yTrain)
xTest   = np.zeros([len(x_orig_test), col_count])
yTest   = np.array(y_orig_test)
yTest  -= min(yTest)

for i in range(len(x_orig)):
    row = x_orig[i]
    for key in row:
        xTrain[i, key - min_feature_idx]=row[key]

for i in range(len(x_orig_test)):
    row = x_orig_test[i]
    for key in row:
        xTest[i, key - min_feature_idx]=row[key]

filename = dataset+'Train.lvq'
fh = open (filename, 'w')
fh.write('{0}\n'.format(col_count))
for i in range (xTrain.shape[0]):
	for j in range(xTrain.shape[1]):
		fh.write('{0} '.format(xTrain[i,j]))
	fh.write('{0}\n'.format(int(yTrain[i])))
	
filename = dataset+'Test.lvq'
fh = open (filename, 'w')
fh.write('{0}\n'.format(col_count))
for i in range (xTest.shape[0]):
	for j in range(xTest.shape[1]):
		fh.write('{0} '.format(xTest[i,j]))
	fh.write('{0}\n'.format(int(yTest[i])))
